#!/bin/bash
##########################################
# File Name:43_array_calculate.sh
# Version:V1.0
# Author:zhangpeng
# 0rganization:linuxjk.cn
# Desc:案例43：求出数组中的值的总和，平均值，最大值，最小值
source /funcs/func_diy.sh
###########################################

#1.vars
function input(){
read -p "请输入需要计算的数字，以空格分割，不限制个数：  " -a array
}

#2.检查数组是否为空
function check_z(){
if [ -z $array ];then
	redecho "未获取到内容，请重新输入！ "
	exit 1
fi
}

#易错提示：检查输入的数组是否为数字
#(错误，这里的正则匹配会将整个数组合成一个整体的字符串进行正则匹配，
#无法逐个检测数组中的元素是否为数字）
#if [[ ! ${array[@]} =~ ^[+-]?[0-9]+\.?[0-9]+$ ]];then
#	echo "格式错误，请输入数字！ "
#	exit 2
#fi

#下面的错误为如果碰到异常数据会直接退出脚本，不会继续运算
#function check_isnumber(){
#for num in "${array[@]}"
#do
#    # 允许整数、小数、负数，排除空值
#    if [[ ! $num =~ ^[+-]?[0-9]+([.][0-9]+)?$ ]] || [[ $num == '.'* ]] || [[ $num == *'.' ]]; then
#        redecho "错误：'$num' 不是有效的数字！"
#        exit 2
#
#    fi
#done
#}

#3.检查数组中的每个值是否为数字，如果有不是数字的进行提示并跳过这一项，继续进行下面的值的计算，
#得到一个过滤异常数据之后的新数组
i=0
#从下标0开始传入数据
function check_isnumber(){
for num in "${array[@]}"
do
	if [[ ! $num =~ ^[+-]?[0-9]+([.][0-9]+)?$ ]] || [[ $num == '.'* ]] || [[ $num == *'.' ]]; then
		redecho "错误！$num 不是有效的数字,此项无法参与运算"
		continue
	else
		newarray[i]=$num
		let i++
	fi
done
}
echo ${newarray[@]}
#4.开始计算
function  calculate(){
total=$(echo ${newarray[@]} | tr -s ' ' '+' |bc -l)
averavg=$(awk -v a=${total} -v b=${#newarray[@]} 'BEGIN{print a/b}')
max=$(echo ${newarray[@]} | sed 's# #\n#g' | sort -rn | head -n1)
min=$(echo ${newarray[@]} | sed 's# #\n#g' | sort -n | head -n1)
}

#5.输出结果
function output(){
cat<<EOF
数组中的值的计算结果如下：
总和：$total
平均值：$averavg
最大值：$max
最小值：$min
EOF
}


function main(){
	input "$@"
	check_z
	check_isnumber
	calculate
	output
}
main
